"""
URL configuration for envipath project.

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/4.2/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""

from django.conf import settings as s
from django.contrib import admin
from django.urls import include, path

from .api import api_v1, api_legacy

PATH_PREFIX = s.SERVER_PATH
if PATH_PREFIX and not PATH_PREFIX.endswith("/"):
    PATH_PREFIX += "/"


urlpatterns = [
    path(f"{PATH_PREFIX}", include("epdb.urls")),
    path(f"{PATH_PREFIX}admin/", admin.site.urls),
    path(f"{PATH_PREFIX}api/v1/", api_v1.urls),
    path(f"{PATH_PREFIX}api/legacy/", api_legacy.urls),
    path(f"{PATH_PREFIX}o/", include("oauth2_provider.urls", namespace="oauth2_provider")),
]

if "migration" in s.INSTALLED_APPS:
    urlpatterns.append(path(f"{PATH_PREFIX}", include("migration.urls")))

if s.MS_ENTRA_ENABLED:
    urlpatterns.append(path(f"{PATH_PREFIX}", include("epauth.urls")))

if s.TENANT != "public":
    urlpatterns.append(path(f"{PATH_PREFIX}", include(f"{s.TENANT}.urls")))

# Custom error handlers
handler400 = "epdb.views.handler400"
handler403 = "epdb.views.handler403"
handler404 = "epdb.views.handler404"
handler500 = "epdb.views.handler500"
